#include "head.h"

int stage[STAGE_HEIGHT][STAGE_WIDTH];
int block[BLOCK_KAZU][BLOCK_SIZE][BLOCK_SIZE];
int index[BLOCK_SIZE][BLOCK_SIZE];
int index_x, index_y;

int end_flag;
long count;
/* -------------------------------------------------------- */

void turn();
void add();
void del();
int crush(int, int);

/* disp.c */
extern void disp_cls();
extern void disp_stage();
extern void disp_block(int, int, int);
extern void disp_index(int);

/* key.c */
extern void key_chk();

/* set.c */
extern void set_block();
extern void set_rand();
extern void set_stage();
extern void set_index();

/* vsync.c */
extern void vsync_set();
extern void vsync_restore();

/* error.c */
extern void _error(char *, char *, int);
/* -------------------------------------------------------- */
void main()
{
									/* ϐ */
	count = end_flag = 0;

	CURSOLE_OFF();
	set_rand();
	set_block();
	set_stage();
	set_index();
									/* Q[Jn */
	disp_cls();
	disp_stage();
	disp_index(1);

	vsync_set();

	while(!end_flag){

		while(!end_flag && count < COUNT_MAX){
			key_chk();
		}
		count = 0;

   		if( crush(index_x, index_y+1) ){
			disp_index(0);
			index_y++;
			disp_index(1);
		}else{
			add();
			del();
			set_index();
		}

	}

	vsync_restore();
	CURSOLE_ON();
	disp_cls();
}
/* -------------------------------------------------------- */
void del()
{
    int x, y, yy, flag;

//	for(y=STAGE_HEIGHT-2; y>0; y--){
	for(y=0; y<STAGE_HEIGHT-1; y++){

		flag = 1;

		for(x=1; x<STAGE_WIDTH-1; x++){
			if(stage[y][x] == 0){
				flag = 0;
			}
		}

		if( flag == 1 ){
			for(yy=y; yy>0; yy--){
				for(x=1; x<STAGE_WIDTH-1; x++){
					stage[yy][x] = stage[yy-1][x];
				}
			}
			disp_stage();
		}
	}
}

/* -------------------------------------------------------- */
void add()
{
	int x,y, flag=1;

	for(y=0; y<BLOCK_SIZE; y++)
		for(x=0; x<BLOCK_SIZE; x++)
			if(index[y][x])
				stage[y+index_y][x+index_x] = 1;
}

/* -------------------------------------------------------- */
void turn()
{
	int x,y, flag=1;
	int tmp[BLOCK_SIZE][BLOCK_SIZE];

	for(y=0; y<BLOCK_SIZE; y++){
		for(x=0; x<BLOCK_SIZE; x++){
			 tmp[(BLOCK_SIZE-1)-x][y] = index[y][x];    /* hidari mwari */
		}
	}

	for(y=0; y<BLOCK_SIZE; y++)
		for(x=0; x<BLOCK_SIZE; x++)
			if(tmp[y][x])
				if(stage[y+index_y][x+index_x]){
					flag=0;
					break;
				}


	if( flag ){
		for(y=0; y<BLOCK_SIZE; y++)
			for(x=0; x<BLOCK_SIZE; x++)
				index[y][x] = tmp[y][x];
	}
}
/* -------------------------------------------------------- */
int crush(int idx_x, int idx_y)
{
	int x, y;

	for(y=0; y<BLOCK_SIZE; y++)
		for(x=0; x<BLOCK_SIZE; x++)
			if(index[y][x])
				if(stage[y+idx_y][x+idx_x])
					return 0;

	return 1;

}
